#ifndef EMIF_CONFIG_H_
#define EMIF_CONFIG_H_


extern void         EMIF_Init                   (void);

extern void         EMIF_ASYNC_MEM_CONFIG       ( unsigned int ASYNC_Mem_Config,
                                                  unsigned int ASYNC_MEM_READ_CONF,
                                                  unsigned int ASYNC_MEM_WRITE_CONF,
                                                  unsigned int ASYNC_MEM_TURN_ARND_CYC,
                                                  unsigned int Chip_Sel);

extern void         FILL_EMIF_MEMORY_32BIT      ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern void         FILL_EMIF_MEMORY_16BIT      ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern void         FILL_EMIF_MEMORY_8BIT       ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern unsigned int CHECK_EMIF_MEMORY_32BIT     ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern unsigned int CHECK_EMIF_MEMORY_16BIT     ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern unsigned int CHECK_EMIF_MEMORY_8BIT      ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern void         FILL_EMIF_MEMORY_32BIT_ADR  ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words);

extern unsigned int CHECK_EMIF_MEMORY_32BIT_ADR ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words);

extern void         FILL_EMIF_MEMORY_BACKWARD   ( unsigned int *Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern void      ENDLESS_EMIF_MEMORY_READ_16BIT ( unsigned int Start_Address );

extern unsigned int TEST_EMIF_MEMORY_32BIT      ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern unsigned int TEST_EMIF_MEMORY_16BIT      ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);
 
extern unsigned int TEST_EMIF_MEMORY_8BIT       ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words,
                                                  unsigned int Pattern);

extern unsigned int TEST_EMIF_MEMORY_ADR        ( unsigned int Start_Address, 
                                                  unsigned int No_Of_Words);

#endif /*EMIF_CONFIG_H_*/
